"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const cli_1 = require("@teambit/cli");
const compiler_1 = require("@teambit/compiler");
const logger_1 = require("@teambit/logger");
const schema_1 = require("@teambit/schema");
const babel_aspect_1 = require("./babel.aspect");
const babel_compiler_1 = require("./babel.compiler");
const babel_parser_1 = require("./babel.parser");
class BabelMain {
    constructor(logger, compiler) {
        this.logger = logger;
        this.compiler = compiler;
    }
    createCompiler(options) {
        return new babel_compiler_1.BabelCompiler(babel_aspect_1.BabelAspect.id, this.logger, this.compiler, options);
    }
    getPackageJsonProps() {
        return {
            main: 'dist/{main}.js',
        };
    }
    static provider([schema, loggerExt, compiler]) {
        return __awaiter(this, void 0, void 0, function* () {
            schema.registerParser(new babel_parser_1.BabelParser());
            const logger = loggerExt.createLogger(babel_aspect_1.BabelAspect.id);
            return new BabelMain(logger, compiler);
        });
    }
}
exports.BabelMain = BabelMain;
BabelMain.runtime = cli_1.MainRuntime;
BabelMain.dependencies = [schema_1.SchemaAspect, logger_1.LoggerAspect, compiler_1.CompilerAspect];
babel_aspect_1.BabelAspect.addRuntime(BabelMain);
//# sourceMappingURL=babel.main.runtime.js.map